local _, class = UnitClass("player")
if class ~= "DEATHKNIGHT" then
    return
end
    
local RuneMover = CreateFrame("frame")

local runes = {} 
for i = 1, 6 do 
    runes[i] = _G["RuneButtonIndividual"..i]
    runes[i]:SetClampedToScreen(true)
    runes[i]:SetFrameStrata("HIGH")
    runes[i]:EnableMouse(false)
end

function RuneMover_OnLoad(self)
    self:SetScript("OnEvent", RuneMover_OnEvent)
    self:RegisterEvent("ADDON_LOADED");
    self:RegisterEvent("PLAYER_REGEN_DISABLED");
    self:RegisterEvent("PLAYER_REGEN_ENABLED");
    self:RegisterEvent("PLAYER_ENTERING_WORLD");
    self:RegisterEvent("PLAYER_LEAVING_WORLD");
    self:RegisterEvent("UNIT_ENTERED_VEHICLE");
    self:RegisterEvent("UNIT_EXITED_VEHICLE");
end

function RuneMover_OnEvent(self, event, arg1, ...)
    if (event == "ADDON_LOADED" and arg1 == "RuneMover") then
        RuneMover_Update();
    elseif (event == "PLAYER_REGEN_DISABLED") then
        RuneFrame:SetAlpha(RMDB.alphain)
    elseif (event == "PLAYER_REGEN_ENABLED" or event == "PLAYER_ENTERING_WORLD") then
        RuneFrame:SetAlpha(RMDB.alphaout)
    elseif (event == "PLAYER_LEAVING_WORLD") then
        RuneMover_Save();
    elseif (event == "UNIT_EXITED_VEHICLE") then
        timer = 4
        RuneMover:SetScript("OnUpdate", RuneMover_OnUpdate)
    elseif (event == "UNIT_ENTERED_VEHICLE") then
        RuneFrame:Hide()
    end
end

function RuneMover_Update()
    for i = 1, 6 do
        runes[i]:SetScale(RMDB.scale)
    end
    RuneMover_Orientation();
end

function RuneMover_Orientation(newValue) 
    RuneMover_Clear();
    if RMDB.layout == "1" then
        runes[1]:SetPoint(RMDB.point, RMDB.parent, RMDB.parentPoint, RMDB.x, RMDB.y)
        runes[2]:SetPoint("BOTTOM", runes[1], "BOTTOM", 0, -22)
        runes[3]:SetPoint("BOTTOM", runes[2], "BOTTOM", 0, -22)
        runes[4]:SetPoint("BOTTOM", runes[3], "BOTTOM", 0, -22)
        runes[5]:SetPoint("BOTTOM", runes[4], "BOTTOM", 0, -22)
        runes[6]:SetPoint("BOTTOM", runes[5], "BOTTOM", 0, -22)
    elseif RMDB.layout == "0" then
        runes[1]:SetPoint(RMDB.point, RMDB.parent, RMDB.parentPoint, RMDB.x, RMDB.y)
        runes[2]:SetPoint("LEFT", runes[1], "RIGHT", 4, 0)
        runes[3]:SetPoint("LEFT", runes[2], "RIGHT", 4, 0)
        runes[4]:SetPoint("LEFT", runes[3], "RIGHT", 4, 0)
        runes[5]:SetPoint("LEFT", runes[4], "RIGHT", 4, 0)
        runes[6]:SetPoint("LEFT", runes[5], "RIGHT", 4, 0)
    elseif RMDB.layout == "2" then
        runes[1]:SetPoint(RMDB.point, RMDB.parent, RMDB.parentPoint, RMDB.x, RMDB.y)
        runes[2]:SetPoint("LEFT", runes[1], "RIGHT", 4, 0)
        runes[3]:SetPoint("BOTTOM", runes[1], "BOTTOM", 0, -22)
        runes[4]:SetPoint("BOTTOM", runes[2], "BOTTOM", 0, -22)
        runes[5]:SetPoint("BOTTOM", runes[3], "BOTTOM", 0, -22)
        runes[6]:SetPoint("BOTTOM", runes[4], "BOTTOM", 0, -22)
    elseif RMDB.layout == "3" then
        runes[1]:SetPoint(RMDB.point, RMDB.parent, RMDB.parentPoint, RMDB.x, RMDB.y)
        runes[2]:SetPoint("LEFT", runes[1], "RIGHT", 6, 26)
        runes[3]:SetPoint("LEFT", runes[1], "RIGHT", 40, 36)
        runes[4]:SetPoint("LEFT", runes[3], "RIGHT", 12, 0)
        runes[5]:SetPoint("LEFT", runes[1], "RIGHT", 102, 26)
        runes[6]:SetPoint("LEFT", runes[1], "RIGHT", 125, 0)
    end
end

function RuneMover_Save()
    RMDB.point, RMDB.parent, RMDB.parentPoint, RMDB.x, RMDB.y = runes[1]:GetPoint(1)
end

function RuneMover_Clear()
    for i = 1, 6 do
        runes[i]:ClearAllPoints()
    end
end

local timer = 0
function RuneMover_OnUpdate(self, elapsed)
    timer = timer - elapsed
    RuneMover_Clear();
    
    if timer < 0 then
        RuneFrame:Show();
        RuneMover_Orientation();
        self:SetScript("OnUpdate", nil)
    end
end

local font = RuneMover:CreateFontString("font", "ARTWORK", "GameFontNormal")
function RuneMover_Lock(newValue)
    if newValue == "1" then
        font:SetText("|cffffffffX|r")
        font:SetPoint("CENTER", runes[1])
        font:Show();
        runes[1]:EnableMouse(true)
        runes[1]:SetMovable(true)
        runes[1]:RegisterForDrag("LeftButton")
        runes[1]:SetScript("OnDragStart", function() runes[1]:StartMoving() end)
        runes[1]:SetScript("OnDragStop", function() runes[1]:StopMovingOrSizing() end)
    elseif newValue == "0" then
        font:Hide();
        runes[1]:EnableMouse(false)
        runes[1]:SetMovable(false)
    end
end

function Slider_ValueChanged(newValue)
    for i = 1, 6 do
        runes[i]:SetScale(newValue)
    end
end

function Alphaout_ValueChanged(self, value)
    RuneFrame:SetAlpha(RMDB.alphaout)
end

SlashCmdList["RUNEMOVER"] = function(msg)
        RuneMover_SlashHandler(string.lower(msg));
end

SLASH_RUNEMOVER1 = "/runemover"
SLASH_RUNEMOVER2 = "/rm"

function RuneMover_SlashHandler(msg)
    local frame = LibStub("Portfolio").GetOptionsFrame("RuneMover")
    InterfaceOptionsFrame_OpenToCategory(frame)
end

RuneMover_OnLoad(RuneMover)